#define ZX80
#define STD_PIECE
;#define QUEENSPAWN

#ifdef ZX80
	.org $4000
;
;	SYSTEM VARIABLES ======================================================
;
	.db $FF		; ERR_NR - error code
	.db $88		; FLAGS
	.dw $FFFE	; PPC	 - line number which is to be executed next
	.dw eof_Vars+1	; E_ADDR
	.dw $270F	; E_PPC	 - line number for LIST
	.dw eof_Prg	; VARS	 - pointer to VARS / end of BASIC PROGRAM
	.dw eof_Vars	; E_LINE - pointer to INPUT BUFFER (-save area end-)
	.dw eof_Vars+2	; D_FILE - pointer to VRAM / end of INPUT BUFFER
	.dw eof_Vars+3	; DF_EA
	.dw eof_Vars+3	; DF_END
	.db $02		; DF_SZ
	.dw $270F	; S_TOP
	.dw $0000	; X_PTR
	.dw $0000	; OLDPPC - line number for CONTINUE
	.db $00		; FLAGX
	.dw $07B0	; T_ADDR
	.dw $0000	; SEED	 - random generator seed
	.dw $241E	; FRAMES - frames counter
	.dw $0000	; V_ADDR
	;
	.dw $0000	; ACC
	.dw $1721	; S_POSN
	.dw $4058	; CH_ADD - BASIC program pointer
;
;	BASIC PROGRAM @ $4028 (16424) =========================================
;
	.db $00,$01			; 1. sor
	.db $EF,$3A,$38,$37		; RANDOMISE USR
	.db $DA,$1D,$22,$20,$20,$1D,$D9	; (16441) : $4039 => INIT
	.db $76				; N/L
	;
	.db $76,$00,$FE			; 2. sor REM
	;
	jp INIT
#else
	.org $4009		; 16393

	.db 0			; VERSN
	.dw $0000		; E_PPC
	.dw $0000		; D_FILE
	.dw $0000		; DF_CC
	.dw Variables		; VARS
	.dw $0000		; DEST
	.dw eof_Vars 		; E_LINE
	.dw eof_Vars+4		; CH_ADD
	.dw $0000		; X_PTR
	.dw $0000		; STKBOT
	.dw $0000		; STKEND
	.db 0			; BREG
	.dw $0000		; MEM
	.db 0			; UNUSED1
	.db 0			; DF_SZ
	.dw $0000		; S_m83
	.dw $0000		; LAST_K
	.db 00			; DEBOUN
	.db 00			; MARGIN
	.dw Begin		; NXTLIN  -  autostart
	.dw 0			; OLDPPC
	.db 0			; FLAGX
	.dw $0000		; STRLEN
	.dw $0000		; T_ADDR
	.dw $0000		; SEED

	.dw $0000		; FRAMES

	.dw $0000		; COORDS
	.db $0000		; PR_CC
	.dw $0000		; S_POSN
	.db $00			; CDFLAG  -  default: '0100000x' (eg. $40)
#endif
;
;	=======================================================================
;
	inc a			; else set bottom border count $56 (86)
	inc a			; 84+17*8+86+6=312 scan lines for PAL mode
;initNTSC
	ld (brd_Btm),a		; Store the bottom border count.
	ld sp,MainLoop		; let's play
;
;	=======================================================================
MainLoop
isNTSC	.equ $+1

	;jr $+2			; env_PAL		;
	;
	call frm_DLY		; 
	;
	jr MainLoop		; let's play
;
;	=======================================================================
;
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	.db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
;
;	=======================================================================
frm_DLY
	ld bc,$5800		; delay -12! => 1161
frm_GEN
	djnz $		; delay - if it is necessary
;
;	-----------------------------------------------------------------------
;
	ld b,$e0	; 
	ld c,$07	; 
	ld a,$a0	;
sto_VSP
	out (c),a	; Turn off the vertical sync generator.
;
;	-----------------------------------------------------------------------
;	Generate the top border and main display area.
brd_Top	.equ $+1

	ld bc,$1238	; There are 18 "HALTs" within the display file, i.e. 17
			; rows and 1 top border. (B)
			; C is set only to achieve perfect timing.
			; There are 56 scan lines (UK) above the ZX80
			; main display area, or 32 for USA models.

	call DF_upper	; Produce the top border and main area.
;
;	-----------------------------------------------------------------------
;	Generate the bottom border.
;
brd_Btm	.equ $+1

	ld c,$38	; the blank line counter, i.e. 56 or 32
	inc b		; scan lines below the ZX80 main display area.

	call DF_lower	; Produce the bottom border.
;
;	-----------------------------------------------------------------------
;	Start the vertical sync pulse.
sta_VSP
	in a,($FE)	; Turn on the vertical sync generator. It will be...
	;
	ret		; ...turned off approximately 6 scanlines from now.
;
;	=======================================================================
#ifdef ZX80
m01	.equ $04	; mosaic "' "
m02	.equ $05	; mosaic " '"	
m03	.equ $83	; mosaic "''"
m04	.equ $06	; mosaic ". "
m05	.equ $02	; mosaic ": "
m06	.equ $08	; mosaic ".'"
m07	.equ $87	; mosaic ":'"
m09	.equ $0A	; mosaic ""
m81	.equ $84	; mosaic ".:"
m82	.equ $85	; mosaic ":."
m83	.equ $03	; mosaic ".."
m84	.equ $86	; mosaic "':"
m85	.equ $82	; mosaic " :"
m86	.equ $88	; mosaic "'."
m87	.equ $07	; mosaic " ."
m89	.equ $8A	; mosaic ""
m8A	.equ $8B	; mosaic ""
c18	.equ $15	; char "/"
i8B	.equ $81	; inverse """
i95	.equ $93	; inverse "+"
i96	.equ $92	; inverse "-"
i97	.equ $94	; inverse "*"
i98	.equ $95	; inverse "/"
#else
m01	.equ $01	; mosaic "' "
m02	.equ $02	; mosaic " '"	
m03	.equ $03	; mosaic "''"
m04	.equ $04	; mosaic ". "
m05	.equ $05	; mosaic ": "
m06	.equ $06	; mosaic ".'"
m07	.equ $07	; mosaic ":'"
m09	.equ $09	; mosaic ""
m81	.equ $81	; mosaic ".:"
m82	.equ $82	; mosaic ":."
m83	.equ $83	; mosaic ".."
m84	.equ $84	; mosaic "':"
m85	.equ $85	; mosaic " :"
m86	.equ $86	; mosaic "'."
m87	.equ $87	; mosaic " ."
m89	.equ $89	; mosaic ""
m8A	.equ $8A	; mosaic ""
c18	.equ $18	; char "/"
i8B	.equ $8B	; inverse """
i95	.equ $95	; inverse "+"
i96	.equ $96	; inverse "-"
i97	.equ $97	; inverse "*"
i98	.equ $98	; inverse "/"
#endif
;
;	=======================================================================
DF_lower
	ld a,$F3		; set the timing counter
DF_init
	ld ix,DF_exec		; init IX 
	ld iy,jp_IY		; and IY
	add a,$01		;
	jr ld_RA		; delay
wt_32TS
	ld a,$E6		; set the timing counter
ld_RA
	ld r,a			; (R=$E6)
	ei			; (R=$E7)
	nop			; (R=$E8) delay
	jp (ix)			; (R=$EA) execute 
;
;	=======================================================================
;
DF_exec	.equ $+$8000

	jp (IY)			;
DF_upper
	ld a,$F3		; set the timing counter
	jr DF_init		; delay
;
;	=======================================================================
;	jp (IY)			; (R=$FD)
jp_IY
	ld hl,wt_32TS		; (R=$FE)
	ld de,19		; (R=$FF)
wt_eol
	halt			; (R=$80)
;
;	... THE 'INTERRUPT' ...	  jp (hl)
;
	ld r,a			; (R=$E6)
	add ix,de		; (R=$E8)
	jp (ix)			; (R=$EA) execute DFile
;
;	=======================================================================
;
;
#ifdef STD_PIECE	; standard pieces:	QZYXWYZQ
;						TTTTTTTT
whP	.equ $39	; white Pawn	"T"
blP	.equ whP+$80	; black Pawn
whR	.equ $36	; white Rook	"Q"
blR	.equ whR+$80	; black Rook
whN	.equ $3F	; white kNight	"Z"
blN	.equ whN+$80	; black kNight
whB	.equ $3E	; white Bishop	"Y"
blB	.equ whB+$80	; black Bishop
whQ	.equ $3D	; white Queen	"X"
blQ	.equ whQ+$80	; black Queen
whK	.equ $3C	; white King	"W"
blK	.equ whK+$80	; black King
;
#endif
;
;	=======================================================================
;
#ifdef QUEENSPAWN
;
OpenPwn	.equ $20	;
wKP	.equ whP	;
wQP	.equ $80	;
;
#else
;
OpenPwn	.equ $1E	;
wKP	.equ $00	;
wQP	.equ whP	;
;
#endif
;	=======================================================================
;
DFile
	.db m82,m83,m81,$80,m82,m83,m81,$80,m82,m83,m81,$80,m82,m83,m81,$80,$80,$FD,$E9
	.db m05,whR,m85,whN,m05,whB,m85,whK,m05,whQ,m85,whB,m05,whN,m85,whR,$80,$FD,$E9
	.db m07,m03,m86,m83,m06,m03,m86,m83,m06,m03,m86,m83,m06,m03,m86,m83,m81,$FD,$E9
	.db $80,whP,m05,whP,m85,whP,m05,wKP,m85,wQP,m05,whP,m85,whP,m05,whP,m85,$FD,$E9
	.db m82,m83,m06,m03,m86,m83,m06,m03,m86,m83,m06,m03,m86,m83,m06,m03,m84,$FD,$E9

;	.db m05,$00,m85,$80,m05,$00,m85,$80,m05,$00,m85,$80,m05,$00,m85,$80,$80,$FD,$E9
;	.db m07,m03,m86,m83,m06,m03,m86,m83,m06,m03,m86,m83,m06,m03,m86,m83,m81,$FD,$E9
;	.db $80,$80,m05,$00,m85,$80,m05,$00,m85,$80,m05,$00,m85,$80,m05,$00,m85,$FD,$E9
;	.db m82,m83,m06,m03,m86,m83,m06,m03,m86,m83,m06,m03,m86,m83,m06,m03,m84,$FD,$E9
;	.db m05,$00,m85,$80,m05,$00,m85,$80,m05,$00,m85,$80,m05,$00,m85,$80,$80,$FD,$E9
;	.db m07,m03,m86,m83,m06,m03,m86,m83,m06,m03,m86,m83,m06,m03,m86,m83,m81,$FD,$E9
;	.db $80,$80,m05,$00,m85,$80,m05,$00,m85,$80,m05,$00,m85,$80,m05,$00,m85,$FD,$E9
;	.db m82,m83,m06,m03,m86,m83,m06,m03,m86,m83,m06,m03,m86,m83,m06,m03,m84,$FD,$E9

	.db m05,blP,m85,blP,m05,blP,m85,blP,m05,blP,m85,blP,m05,blP,m85,blP,$80,$FD,$E9
	.db m07,m03,m86,m83,m06,m03,m86,m83,m06,m03,m86,m83,m06,m03,m86,m83,m81,$FD,$E9
	.db $80,blR,m05,blN,m85,blB,m05,blK,m85,blQ,m05,blB,m85,blN,m05,blR,m85,$FD,$E9
	.db $80,$80,m07,m03,m84,$80,m07,m03,m84,$80,m07,m03,m84,$80,m07,m03,m84,$FD,$E9
endof_DF	
;	=======================================================================
#ifndef ZX80
Begin
	.db $00,$01		; Basic Line 1
	.dw Variables-RAND_USR	; Length of Basic Line 1
RAND_USR
	.db $F9,$D4,$26,$76	; RAND USR A
;
; ========================================================== Variables area
Variables
	.db $66,$8F		;
	.db dblINI/256		;
	.db dblINI&255		;
	.db $00,$00		; A=INIT
#endif
;
;	=======================================================================
INIT
dblINI	.equ (2*INIT)& $7FFF
	;
	ld hl,to4003		;
	ld de,$4003		;
	ld bc,eof_Prg-to4003	;
	ldir			;
	jp $4003		;
	;
	; ---------------------------------------------------------------------
to4003
	ld de,$43ff		;
	ld l,(endof_DF-1)&255	;
	ld c,152		; (8*19=152)
	lddr			;
	;
	ld hl,endof_DF+75	;
	ld c,22			;
	lddr			;
	;
	ld de,$0480		;
	ld c,22			;
	xor a			;
to4003a
	ld b,8			;
to4003b
	ld (hl),a		;
	xor e			;
	dec hl			;
	dec hl			;
	djnz to4003b		;
	;
	xor e			;
	sbc hl,bc		;
	dec d			;
	jr nz,to4003a		;
	;
	ld a,(hl)		;
	ld e,OpenPwn		;
	add hl,de		;
	ld (hl),a		;
	;
	in a,($FE)		; Read the input port.
        rla			;
        rla			; Test bit 6 (the region indicator).
        sbc a,a			; $FF (UK) or $00 (USA).
        and $18			; $18 (UK) or $00 (USA).
        add a,$3C		; $54 (UK) or $3C (USA), i.e. 84 (UK) or 60 (USA).
	ld (brd_Top),a		; Store the top border count.
	;
        cp $54			; PAL?
	jr c,$+4		; no, initNTSC
	;
;	inc a			; else set bottom border count $56 (86)
;	inc a			; 84+17*8+86+6=312 scan lines for PAL mode
;initNTSC
;	ld (brd_Btm),a		; Store the bottom border count.
;
;	=======================================================================
eof_Prg
	.db $80
eof_Vars
.end

 
